﻿-- SeeCD Settings module
-- v 1.2

---
local _, L = ...;


---
local SCDO = L

SCDO.dirDB = {
	[L["s_dd1 up"]] = 0,
	[L["s_dd1 down"]] = 1,
	[L["s_dd1 left"]] = 2,
	[L["s_dd1 right"]] = 3,
}

SCDO.fontsDB = {
	[L["s_dd2 large"]] = 2.5,
	[L["s_dd2 mid"]] = 2,
	[L["s_dd2 small"]] = 1.6,
}


---
function SCDO.CreateConfig()

	SCDO.F = CreateFrame( "Frame", nil, UIParent );
	SCDO.F.name = L["addon title"];
	InterfaceOptions_AddCategory(SCDO.F);
 
	SCDO.S = CreateFrame( "Frame", nil, SCDO.F);
	SCDO.S.name = L["settings title"];
	SCDO.S.parent = SCDO.F.name;
	InterfaceOptions_AddCategory(SCDO.S);

	SCDO.Z = CreateFrame( "Frame", nil, SCDO.F);
	SCDO.Z.name = L["zones title"];
	SCDO.Z.parent = SCDO.F.name;
	InterfaceOptions_AddCategory(SCDO.Z);

	SCDO.A = CreateFrame( "Frame", nil, SCDO.F);
	SCDO.A.name = L["about title"];
	SCDO.A.parent = SCDO.F.name;
	InterfaceOptions_AddCategory(SCDO.A);


-- addon menu
	SCDO.F.title = SCDO.F:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	SCDO.F.title:SetPoint("TOPLEFT", 16, -16)
	SCDO.F.title:SetText(L["addon name"])

	SCDO.F.subtitle = SCDO.F:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	SCDO.F.subtitle:SetPoint("TOPLEFT", SCDO.F.title, "BOTTOMLEFT", 0, -8)
	SCDO.F.subtitle:SetNonSpaceWrap(true)
	SCDO.F.subtitle:SetText(L["addon author"])
	SCDO.F.subtitle:SetTextColor(1, 1, 1, 0.5)


-- settings menu
	SCDO.S.title = SCDO.S:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	SCDO.S.title:SetPoint("TOPLEFT", 16, -16)
	SCDO.S.title:SetText(L["settings contents"])

	SCDO.S.checkbox1 = CreateFrame("CheckButton", "scheckbox1", SCDO.S, "ChatConfigCheckButtonTemplate")
	SCDO.S.checkbox1:SetPoint("TOPLEFT", SCDO.S.title, "BOTTOMLEFT", 0, -10)
	_G[SCDO.S.checkbox1:GetName().."Text"]:SetText(L["s_cb1 desc"])
	_G[SCDO.S.checkbox1:GetName().."Text"]:SetPoint("LEFT", SCDO.S.checkbox1, "RIGHT", 3, 1)
	SCDO.S.checkbox1.tooltip = L["s_cb1 tooltip"]
	SCDO.S.checkbox1:Show()
	SCDO.S.checkbox1:SetScript("OnClick", function(self, button, down)
		if SCDO.S.checkbox1:GetChecked() then
			SCDO.db.movePanels = true
			SCDO.targetFrame:SetMovable(true)
			SCDO.anchorFrame:Show()
			SCDO.anchorFrame:SetMovable(true)
			SCDO.targetFrame:EnableMouse(true)
			SCDO.anchorFrame:EnableMouse(true)
		else
			SCDO.db.movePanels = false
			SCDO.targetFrame:SetMovable(false)
			SCDO.anchorFrame:Hide()
			SCDO.anchorFrame:SetMovable(false)
			SCDO.targetFrame:EnableMouse(false)
			SCDO.anchorFrame:EnableMouse(false)
		end
	end)

	SCDO.S.button = CreateFrame("Button", "pt_btn", SCDO.S, "UIPanelButtonTemplate2")
	SCDO.S.button:SetHeight(25)
	SCDO.S.button:SetWidth(60)
	SCDO.S.button:SetID(1)
	SCDO.S.button:SetText(L["s_b1 name"])
	SCDO.S.button:SetPoint("LEFT", SCDO.S.title, "RIGHT", 10, -1)

	SCDO.S.checkbox2 = CreateFrame("CheckButton", "scheckbox2", SCDO.S, "ChatConfigCheckButtonTemplate")
	SCDO.S.checkbox2:SetPoint("TOPLEFT", SCDO.S.checkbox1, "BOTTOMLEFT", 0, 0)
	_G[SCDO.S.checkbox2:GetName().."Text"]:SetText(L["s_cb2 desc"])
	_G[SCDO.S.checkbox2:GetName().."Text"]:SetPoint("LEFT", SCDO.S.checkbox2, "RIGHT", 3, 1)
	SCDO.S.checkbox2.tooltip = L["s_cb2 tooltip"]
	SCDO.S.checkbox2:Show()
	SCDO.S.checkbox2:SetScript("OnClick", function(self, button, down)
		if SCDO.S.checkbox2:GetChecked() then
			SCDO.db.shDesc = true
		else
			SCDO.db.shDesc = false
		end
	end)

	SCDO.S.checkbox3 = CreateFrame("CheckButton", "scheckbox3", SCDO.S, "ChatConfigCheckButtonTemplate")
	SCDO.S.checkbox3:SetPoint("TOPLEFT", SCDO.S.checkbox2, "BOTTOMLEFT", 0, 0)
	_G[SCDO.S.checkbox3:GetName().."Text"]:SetText(L["s_cb3 desc"])
	_G[SCDO.S.checkbox3:GetName().."Text"]:SetPoint("LEFT", SCDO.S.checkbox3, "RIGHT", 3, 1)
	SCDO.S.checkbox3.tooltip = L["s_cb3 tooltip"]
	SCDO.S.checkbox3:Show()
	SCDO.S.checkbox3:SetScript("OnClick", function(self, button, down)
		if SCDO.S.checkbox3:GetChecked() then
			SCDO.db.specIcon = true
		else
			SCDO.db.specIcon = false
			SCDO.SpecFrame:Hide()
		end
	end)

	function SCDO.createTestFrame()
		SCDO.testFrame = CreateFrame("frame", "testSpells", SCDO.S)
		SCDO.testFrame:SetPoint("RIGHT", SCDO.S.button, "RIGHT", 284, -22)
		SCDO.testFrame:SetWidth(64*4)
		SCDO.testFrame:SetHeight(64)
		SCDO.testFrame:SetAlpha(SCDO.db.i_alpha)
		SCDO.testFrame:Show()
		SCDO.S.button:SetScript("OnClick", function()
			SCDO.createIcon('test', 5782, (select(1,GetSpellInfo(5782))))
			SCDO.createIcon('test', 1833, (select(1,GetSpellInfo(1833))))
			SCDO.createIcon('test', 32379, (select(1,GetSpellInfo(32379))))
			SCDO.createIcon('test', 100, (select(1,GetSpellInfo(100))))
		end)
	end

   	SCDO.dropdown1 = CreateFrame("Button", "sdropdown1", SCDO.S, "UIDropDownMenuTemplate")
	SCDO.dropdown1:SetPoint("TOPLEFT", SCDO.S.checkbox3, "BOTTOMLEFT", -15, -30)
	SCDO.dropdown1:SetWidth(40)
	SCDO.dropdown1.font = SCDO.dropdown1:CreateFontString("sdropdownFont1", "ARTWORK", "GameFontNormalSmall")
 	SCDO.dropdown1.font:SetPoint("BOTTOMLEFT", SCDO.dropdown1, "TOPLEFT", 20, 0)
	SCDO.dropdown1.font:SetText(L["s_dd1 desc"])
	_G[SCDO.dropdown1:GetName().."Button"]:SetScript("OnClick", function(self, button, down)
		  ToggleDropDownMenu(1, nil, SCDO.dropdown1, self:GetName(), -100 ,0)
	end)

	local info = {}

	function SCDO.dropdown1.initialize(self, level)
		if not level then return end
		wipe(info)
		if level == 1 then
			SCDO.CreateMenu1(info)
		end
	end

	function SCDO.OnClickFunc1(button, arg1, arg2, checked)
		SCDO.db.SeeCDsdirName = arg1
		SCDO.db.SeeCDsdir = arg2
		SCDO.chkDir(1)
		UIDropDownMenu_SetText(SCDO.dropdown1, arg1)
	end	
		
	function SCDO.CreateMenu1(info)
		for k, v in pairs(SCDO.dirDB) do
			info.text = k
			info.isTitle = nil
			info.notCheckable = nil
			info.func = SCDO.OnClickFunc1
			info.arg1 = k
			info.arg2 = v
			info.checked = SCDO.isCurrent1(k)
			UIDropDownMenu_AddButton(info)
		end
	end	

	function SCDO.isCurrent1(dd)
		if SCDO.db.SeeCDsdirName == dd then
			return true
		else
			return false
		end
	end

	SCDO.dropdown2 = CreateFrame("Frame", "sdropdown2", SCDO.S, "UIDropDownMenuTemplate")
	SCDO.dropdown2:SetPoint("TOPLEFT", SCDO.dropdown1, "BOTTOMLEFT", 182, 31)
	SCDO.dropdown2:SetWidth(40)
 	SCDO.dropdown2.font = SCDO.dropdown2:CreateFontString("sdropdownFont2", "ARTWORK", "GameFontNormalSmall")
 	SCDO.dropdown2.font:SetPoint("BOTTOMLEFT", SCDO.dropdown2, "TOPLEFT", 20, 0)
	SCDO.dropdown2.font:SetText(L["s_dd2 desc"])
	_G[SCDO.dropdown2:GetName().."Button"]:SetScript("OnClick", function(self, button, down)
		  ToggleDropDownMenu(1, nil, SCDO.dropdown2, self:GetName(), -100 ,0)
	end)

	local info = {}

	function SCDO.dropdown2.initialize(self, level)
		if not level then return end
		wipe(info)
		if level == 1 then
			SCDO.CreateMenu(info)
		end
	end

	function SCDO.OnClickFunc(button, arg1, arg2, checked)
		SCDO.db.SeeCDsfontSize = arg1
		SCDO.db.SeeCDsfSize = arg2
		UIDropDownMenu_SetText(SCDO.dropdown2, arg1)
	end	
		
	function SCDO.CreateMenu(info)
		for k, v in pairs(SCDO.fontsDB) do
			info.text = k
			info.isTitle = nil
			info.notCheckable = nil
			info.func = SCDO.OnClickFunc
			info.arg1 = k
			info.arg2 = v
			info.checked = SCDO.isCurrent(k)
			UIDropDownMenu_AddButton(info)
		end
	end	

	function SCDO.isCurrent(font)
		if SCDO.db.SeeCDsfontSize == font then
			return true
		else
			return false
		end
	end


	SCDO.slider1 = CreateFrame("Slider", "sslider1", SCDO.S, "OptionsSliderTemplate")
	SCDO.slider1:SetPoint("TOPLEFT", SCDO.dropdown1, "BOTTOMLEFT", 20, -30)
	_G[SCDO.slider1:GetName().."Text"]:SetText(L["s_s1 desc"])
	SCDO.slider1.tooltipText = L["s_s1 tooltip"]
	_G[SCDO.slider1:GetName().."Low"]:SetText("32")
	_G[SCDO.slider1:GetName().."High"]:SetText("64")
	SCDO.slider1:SetWidth(125)
	SCDO.slider1:SetMinMaxValues(32, 64)
	SCDO.slider1:SetValue(32)
	SCDO.slider1:SetValueStep(1)
	SCDO.slider1:SetScript("OnValueChanged", function(self, value)
		SCDO.db.i_size = value
		_G[SCDO.slider1:GetName().."Text"]:SetText(L["s_s1 desc"])
	end)

	SCDO.slider2 = CreateFrame("Slider", "sslider2", SCDO.S, "OptionsSliderTemplate")
	SCDO.slider2:SetPoint("TOPLEFT", SCDO.slider1, "BOTTOMLEFT", 0, -30)
	_G[SCDO.slider2:GetName().."Text"]:SetText(L["s_s2 desc"])
	SCDO.slider2.tooltipText = L["s_s1 tooltip"]
	_G[SCDO.slider2:GetName().."Low"]:SetText("1")
	_G[SCDO.slider2:GetName().."High"]:SetText("5")
	SCDO.slider2:SetWidth(125)
	SCDO.slider2:SetMinMaxValues(1, 5)
	SCDO.slider2:SetValueStep(1)
	SCDO.slider2:SetScript("OnValueChanged", function(self, value)
		SCDO.db.i_offset = value
		_G[SCDO.slider2:GetName().."Text"]:SetText(L["s_s2 desc"])
	end)

	SCDO.slider3 = CreateFrame("Slider", "sslider3", SCDO.S, "OptionsSliderTemplate")
	SCDO.slider3:SetPoint("TOPLEFT", SCDO.slider2, "BOTTOMLEFT", 0, -30)
	_G[SCDO.slider3:GetName().."Text"]:SetText(L["s_s3 desc"])
	SCDO.slider3.tooltipText = L["s_s1 tooltip"]
	_G[SCDO.slider3:GetName().."Low"]:SetText("25%")
	_G[SCDO.slider3:GetName().."High"]:SetText("100%")
	SCDO.slider3:SetWidth(125)
	SCDO.slider3:SetMinMaxValues(0.25, 1)
	SCDO.slider3:SetValueStep(0.05)
	SCDO.slider3:SetScript("OnValueChanged", function(self, value)
		SCDO.db.i_alpha = value
		SCDO.targetFrame:SetAlpha(SCDO.db.i_alpha)
		SCDO.SpecFrame:SetAlpha(SCDO.db.i_alpha)
		SCDO.testFrame:SetAlpha(SCDO.db.i_alpha)
		_G[SCDO.slider3:GetName().."Text"]:SetText(L["s_s3 desc"])
	end)

	SCDO.slider4 = CreateFrame("Slider", "sslider4", SCDO.S, "OptionsSliderTemplate")
	SCDO.slider4:SetPoint("TOPLEFT", SCDO.slider1, "BOTTOMLEFT", 185, 17)
	_G[SCDO.slider4:GetName().."Text"]:SetText(L["s_s4 desc"])
	SCDO.slider4.tooltipText = L["s_s1 tooltip"]
	_G[SCDO.slider4:GetName().."Low"]:SetText("0.01")
	_G[SCDO.slider4:GetName().."High"]:SetText("0.1")
	SCDO.slider4:SetWidth(125)
	SCDO.slider4:SetMinMaxValues(0.01, 0.1)
	SCDO.slider4:SetValueStep(0.01)
	SCDO.slider4:SetScript("OnValueChanged", function(self, value)
		SCDO.db.a_alpha = value
		_G[SCDO.slider4:GetName().."Text"]:SetText(L["s_s4 desc"])
	end)

	SCDO.slider5 = CreateFrame("Slider", "sslider5", SCDO.S, "OptionsSliderTemplate")
	SCDO.slider5:SetPoint("TOPLEFT", SCDO.slider2, "BOTTOMLEFT", 185, 17)
	_G[SCDO.slider5:GetName().."Text"]:SetText(L["s_s5 desc"])
	SCDO.slider5.tooltipText = L["s_s1 tooltip"]
	_G[SCDO.slider5:GetName().."Low"]:SetText("0.5")
	_G[SCDO.slider5:GetName().."High"]:SetText("1.5")
	SCDO.slider5:SetWidth(125)
	SCDO.slider5:SetMinMaxValues(0.5, 1.5)
	SCDO.slider5:SetValueStep(0.1)
	SCDO.slider5:SetScript("OnValueChanged", function(self, value)
		SCDO.db.a_scale = value
		_G[SCDO.slider5:GetName().."Text"]:SetText(L["s_s5 desc"])
	end)


-- zones menu
	SCDO.Z.title = SCDO.Z:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	SCDO.Z.title:SetPoint("TOPLEFT", 16, -16)
	SCDO.Z.title:SetText(L["zones contents"])

	SCDO.Z.checkbox1 = CreateFrame("CheckButton", "zcheckbox1", SCDO.Z, "ChatConfigCheckButtonTemplate")
	SCDO.Z.checkbox1:SetPoint("TOPLEFT", SCDO.Z.title, "BOTTOMLEFT", 0, -10)
	_G[SCDO.Z.checkbox1:GetName().."Text"]:SetText(L["z_cb1 desc"])
	_G[SCDO.Z.checkbox1:GetName().."Text"]:SetPoint("LEFT", SCDO.Z.checkbox1, "RIGHT", 3, 1)
	SCDO.Z.checkbox1.tooltip = L["z_cb1 tooltip"]
	SCDO.Z.checkbox1:Show()
	SCDO.Z.checkbox1:SetScript("OnClick", function(self, button, down)
		if SCDO.Z.checkbox1:GetChecked() then
			SCDO.db.flag1 = 1
			SCDO.db.zcb1 = true
		else
			SCDO.db.flag1 = 0
			SCDO.db.zcb1 = false	
		end
	end)

	SCDO.Z.checkbox2 = CreateFrame("CheckButton", "zcheckbox2", SCDO.Z, "ChatConfigCheckButtonTemplate")
	SCDO.Z.checkbox2:SetPoint("TOPLEFT", SCDO.Z.checkbox1, "BOTTOMLEFT", 0, -10)
	_G[SCDO.Z.checkbox2:GetName().."Text"]:SetText(L["z_cb2 desc"])
	_G[SCDO.Z.checkbox2:GetName().."Text"]:SetPoint("LEFT", SCDO.Z.checkbox2, "RIGHT", 3, 1)
	SCDO.Z.checkbox2.tooltip = L["z_cb2 tooltip"]
	SCDO.Z.checkbox2:Show()
	SCDO.Z.checkbox2:SetScript("OnClick", function(self, button, down)
		if SCDO.Z.checkbox2:GetChecked() then
			SCDO.db.flag2 = 1
			SCDO.db.zcb2 = true
		else
			SCDO.db.flag2 = 0
			SCDO.db.zcb2 = false
		end
	end)

	SCDO.Z.checkbox3 = CreateFrame("CheckButton", "zcheckbox3", SCDO.Z, "ChatConfigCheckButtonTemplate")
	SCDO.Z.checkbox3:SetPoint("TOPLEFT", SCDO.Z.checkbox1, "BOTTOMLEFT", 170, 23)
	_G[SCDO.Z.checkbox3:GetName().."Text"]:SetText(L["z_cb3 desc"])
	_G[SCDO.Z.checkbox3:GetName().."Text"]:SetPoint("LEFT", SCDO.Z.checkbox3, "RIGHT", 3, 1)
	SCDO.Z.checkbox3.tooltip = L["z_cb3 tooltip"]
	SCDO.Z.checkbox3:Show()
	SCDO.Z.checkbox3:SetScript("OnClick", function(self, button, down)
		if SCDO.Z.checkbox3:GetChecked() then
			SCDO.db.inst_bg = 1
			SCDO.db.zcb3 = true
			SCDO.db.inst_ar = 0
			SCDO.db.zcb4 = false
			SCDO.Z.checkbox4:SetChecked(SCDO.db.zcb4)
			SCDO.checkFlags1()
		else
			SCDO.db.inst_bg = 0
			SCDO.db.zcb3 = false
			SCDO.checkFlags1()
		end
	end)

	SCDO.Z.checkbox4 = CreateFrame("CheckButton", "zcheckbox4", SCDO.Z, "ChatConfigCheckButtonTemplate")
	SCDO.Z.checkbox4:SetPoint("TOPLEFT", SCDO.Z.checkbox2, "BOTTOMLEFT", 170, 23)
	_G[SCDO.Z.checkbox4:GetName().."Text"]:SetText(L["z_cb4 desc"])
	_G[SCDO.Z.checkbox4:GetName().."Text"]:SetPoint("LEFT", SCDO.Z.checkbox4, "RIGHT", 3, 1)
	SCDO.Z.checkbox4.tooltip = L["z_cb4 tooltip"]
	SCDO.Z.checkbox4:Show()
	SCDO.Z.checkbox4:SetScript("OnClick", function(self, button, down)
		if SCDO.Z.checkbox4:GetChecked() then
			SCDO.db.inst_ar = 1
			SCDO.db.zcb4 = true
			SCDO.db.inst_bg = 0
			SCDO.db.zcb3 = false
			SCDO.Z.checkbox3:SetChecked(SCDO.db.zcb3)
			SCDO.checkFlags1()
		else
			SCDO.db.inst_ar = 0
			SCDO.db.zcb4 = false
			SCDO.checkFlags1()
		end
	end)


-- about menu
	SCDO.A.title = SCDO.A:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	SCDO.A.title:SetPoint("TOPLEFT", 16, -16)
	SCDO.A.title:SetText(L["addon name"])

	SCDO.A.subtitle = SCDO.A:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	SCDO.A.subtitle:SetPoint("TOPLEFT", SCDO.A.title, "LEFT", 0, -20)
	SCDO.A.subtitle:SetNonSpaceWrap(true)
	SCDO.A.subtitle:SetText(L["about notes"])
	SCDO.A.subtitle:SetTextColor(1, 1, 1, 1)
	SCDO.A.subtitle:SetJustifyH("LEFT")
end